package com.jah0wl.catan;

import javax.microedition.lcdui.*;
import java.util.Enumeration;
import java.util.Vector;
import java.io.IOException;
import java.lang.InterruptedException;
import com.jah0wl.catan.utils.*;
import com.jah0wl.utils.*;
import com.jah0wl.catan.fields.*;
import com.jah0wl.catan.items.City;

class BoardCanvas extends GameCanvas implements CommandListener{

    // para ver si dibujamos toda la pantalla

    // to see if we drew all the screen
    boolean fullScreen = false;

    // Board de juego         // game board
    Board board;

    // variables para mostrar los resources
    // variables to show resources.
    int yShowResources = -72;
    Image imgRecursos;
    Image imgInfo;
    Graphics graphInfo;
    Graphics graphRecursos;

    // Vector of players
    // Vector de jugadores
    Vector players;

    // jugador actual
    Player currentPlayer;
    int playerIndex =0;
    int numPlayers;

    // indices in the vector of players that have biggest army or longest road
    // indices en el vector de los players q tienen
    // bigArmyOwner y ruta comercial
    int bigArmyOwner =-1;                                           // signors, gentlemen,knights
    int ruta_comercial=-1;                    // route commercial

    // Dice
    Dice dice;
    Point initPDice;
    int frameDice = 0;

    // variable for state in which we were
    // variables para el state en el que nos encontramos
    private final static int SELECT_EDGE			= 00000000001;
    private final static int SELECT_VERTICE			= 00000000002;
    private final static int SELECT_FIELD			= 00000000004;
    private final static int SELECT_RESOURCES		= 00000000010;
    private final static int MULTI_SUM_RECURSOS	= 00000000020;
    private final static int MULTI_REMAINING_RESOURCES	= 00000000040;

    private final static int FIRST_SETTLEMENT			= 00000000100;
    private final static int SECOND_SETTLEMENT			= 00000000200;

    private final static int SELECT_WHO				= 00000000400;

    private final static int THROW_DICE			= 00000001000;    //throw dice
    private final static int SHOW_DICE				= 00000002000;    //show dice
    private final static int DICE_THROWN			= 00000004000;    //thrown_dice
    private final static int FIN_DADOS_TIRADOS		= 00000010000;    //fin...

    private final static int SUMA_RECURSOS			= 00000020000;  //adds resources
    private final static int RESTA_RECURSOS			= 00000040000;  //reduces resources

    private final static int SHOW_RESOURCES			= 00000100000;
    private final static int RECURSOS_SHOWN			= 00000200000;
    private final static int SHOW_INFO				= 00000400000;

    private final static int MOVE_ROBBER			= 00001000000;

    private final static int PUT_ROAD			= 00002000000;
    private final static int PUT_SETTLEMENT			= 00004000000;
    private final static int PUT_CITY				= 00010000000;
    private final static int PUT_SHIP				= 00020000000;
    private final static int PLAY_CARD				= 00040000000;

    private final static int SHOW_MAP				= 00100000000;
    private final static int STEALING				= 00200000000;
    private final static int TRADING				= 00400000000;
    private final static int TRADING_ACTUAL			= 01000000000;

    private final static int PORT_TRADE					= 02000000000;
    private final static int EXPANSION				= 04000000000;
    private final static int MONOPOLIO				= 010000000000;

    private int state;


  // present coordinates in this state
    // actual coordenada en el caso de state
    //   (SELECT_VERTICE, SELECT_EDGE, SELECT_FIELD)
    Coordinate coorSelect;

    // Seleccionar resources (SELECT_RESOURCES)
    private int numRecursos_SelRec;
    private int[] recursos_SelRec = new int[5];

    private Rectangle[] rSelection_SelRec = {new Rectangle(3+7,11+18,12,29), new Rectangle(16+7,11+18,12,29),
                                              new Rectangle(29+7,11+18,12,29), new Rectangle(42+7,11+18,12,29),
                                              new Rectangle(55+7,11+18,12,29), new Rectangle(68+8,20+18,13,11)};
    private int current_SelRec;
    private Player jugadorActual_SelRec;


    // Comandos
//    private Command PutRoadCommand = new Command("Poner carretera",Command.ITEM,10);
//    private Command PutSettlementCommand = new Command("Poner poblado",Command.ITEM,11);
//    private Command PutCityCommand = new Command("Poner ciudad",Command.ITEM,12);
//    private Command PutShipCommand = new Command("Poner barco",Command.ITEM,13);
//    private Command BuyCardCommand = new Command("Comprar carta",Command.ITEM,14);
//    private Command PlayCardCommand = new Command("Jugar carta",Command.ITEM,15);
//    private Command TradeCommand = new Command("Intercambiar",Command.ITEM,16);
//    private Command PortTradeCommand = new Command("Cambiar banca",Command.ITEM,17);
//
//    private Command EndTurnCommand = new Command("Pasar turno (5)",Command.ITEM,70);
//
//    private Command showResourcesCommand = new Command("Ver resources (*)",Command.ITEM,80);
//    private Command showInfoCommand = new Command("Ver info (#)",Command.ITEM,81);
//    private Command showMapCommand = new Command("Ver map (8)",Command.ITEM,82);
//
//    private Command CancelCommand = new Command("Cancelar",Command.CANCEL,90);
//
//    private Command exitCommand = new Command("Salir", Command.EXIT, 100);


// commands in English
    private Command PutRoadCommand = new Command("Place road",Command.ITEM,10);
    private Command PutSettlementCommand = new Command("Place settlement",Command.ITEM,11);
    private Command PutCityCommand = new Command("Place city",Command.ITEM,12);
    private Command PutShipCommand = new Command("Place ship",Command.ITEM,13);
    private Command BuyCardCommand = new Command("Buy card",Command.ITEM,14);
    private Command PlayCardCommand = new Command("Play card",Command.ITEM,15);
    private Command TradeCommand = new Command("Trade",Command.ITEM,16);
    private Command PortTradeCommand = new Command("Port trade",Command.ITEM,17);

    private Command EndTurnCommand = new Command("End turn (5)",Command.ITEM,70);

    private Command showResourcesCommand = new Command("Show resources (*)",Command.ITEM,80);
    private Command showInfoCommand = new Command("Show info (#)",Command.ITEM,81);
    private Command showMapCommand = new Command("Show map (8)",Command.ITEM,82);

    private Command CancelCommand = new Command("Cancel",Command.CANCEL,90);

    private Command exitCommand = new Command("Exit", Command.EXIT, 100);



    // Coordinate for the second town of each one.
    // Coordinate para el segundo poblado de cada uno
    Coordinate secondSettlement;

   // For I number of golds that are to select each one in the case of receiving golds by the distance of dices.
   /// Para el numero de oros que ha de seleccionar cada uno en el caso
    // de recibir oros por la tirada de dados
    int[] numGold;
    int[] numRecursos;
    int recursosIndexPlayer = 0;


     // Variable for the robbery of resources by the thief
    // Variables para el robo de resources por el ladron
    int whoIndex;
    int[] playersToStole;
    int whoSize;

    // Variables para el intercambio de resources
    // Variables for exchanging resources between players
    int[] tradeOtherRec = new int[5];
    Player playerTrade;

    // Variables para el intercambio con la banca
    // Variables for port trade (resource exchange with bank)
    int resToChange;
    int resIndex;
    int actual_banca;
    Image bancaImg;
    Graphics bancaGr;

    // list para las cartas de desarrollo                   //desarrollo=develop,unfold
    // list for development cards.
    List listDevelopment;
    boolean isPlayed=false;

    // for the expansion card

    // para la carta de expansion
    int numRoadsExp;

    // Constructor

    /**
     * @param midlet
     * @param j      vector of players
     */
    public BoardCanvas(Catan midlet, Vector j){
        super(midlet);

        // escuchamos los comandos // we listen to commands
    /*	setCommandListener(this);

            // aadimos el comando salir             // exit command
            addCommand(exitCommand);
            addCommand(showResourcesCommand);
            addCommand(showInfoCommand);
            addCommand(showMapCommand);
    */
        // creamos el tablero           //create the board
        board = new Board("hola");

        // inicializamos el vector de players
        this.players =j;
        randomizePlayers();

        // inicializamos los dados
        initPDice = new Point(getWidth()/2+5,getHeight()/2+2);
        dice = new Dice(initPDice);

        // placement options
        // ponemos las opciones de los players
        // we set the parameters of players
        Player.MAX_SHIPS =15;
        Player.MAX_ROADS =15;
        Player.MAX_CITIES =4;
        Player.MAX_SETTLEMENTS =5;
        Player.MAX_POINTS =12;

        // jugador actual
        // current player
        numPlayers =players.size();
        currentPlayer =(Player) players.elementAt(playerIndex);
        // we began mode for the present player has to put town.
        // empezamos de manera q el jugador actual tiene q poner poblado
        state = SELECT_VERTICE | FIRST_SETTLEMENT;
        coorSelect = new Coordinate(1,1,0);

        // inicializamos la coordenada para el segundo poblado
        // we initialized the coordinate for the second settlement
        secondSettlement = new Coordinate(0,0,0);


    // initialize the array of gold to exchange/gather
    // inicializamos el numero de oros a recoger
        numGold = new int[numPlayers];   //numOros
        numRecursos = new int[numPlayers];

        //  the variables for the robbery of players.
        // las variables para el robo a players
        playersToStole = new int[numPlayers];
    }

    public void paint(Graphics g){
        g.setStrokeStyle(g.SOLID);

        //  // If we drew all the screen.
        // Si dibujamos toda la pantalla
        if (fullScreen || (state & SHOW_MAP) != 0 ||
            !((state & (SHOW_RESOURCES | SHOW_INFO | SELECT_RESOURCES | SELECT_WHO |
                         PORT_TRADE | THROW_DICE | DICE_THROWN)) != 0)){

            // dibujamos el tablero
            // draw board
            board.paint(g);

            // dibujamos el rectangulo del color del jugador actual
            // draws rectangle of current player colour
            g.setColor(currentPlayer.getColor()[0],
                       currentPlayer.getColor()[1],
                       currentPlayer.getColor()[2]);
            g.drawRect(0,0,95,64);
            fullScreen=false;
        }

        // draws according to current state
        // dibujamos segun el state actual
        if (!((state & SHOW_MAP) != 0)){
            if ((state & SHOW_RESOURCES) != 0){
                // dibujamos el cuadro de resources
                // draws the picture of resources
                showResources(g);
                if ((state & SHOW_RESOURCES) != 0){
                    repaint();
                }
            }else if ((state & SHOW_INFO) != 0){
                // dibujamos el cuadro de informacion   // draw the information picture
                showInfo(g);
            }else if ((state & SELECT_WHO) != 0){
                // dibujamos el cuadro para elegir a quien robar
                // draw the picture to choose to whom to rob
                showSelectWho(g);
            }else if ((state & SELECT_RESOURCES) != 0){
                // dibujamos el cuadro de seleccionar resources
                // draw the picture to select resources
                showSelectResources(g);
            }else if ((state & PORT_TRADE) != 0){
                // dibujamos el cuadro de seleccionar resources
                showBanca(g);
            }else if ((state & (SELECT_EDGE | SELECT_VERTICE | SELECT_FIELD)) != 0){
                 // dibujamos la casilla q se esta eligiendo actualmente
                showSelectField(coorSelect,g);
            }else if ((state & (THROW_DICE | DICE_THROWN)) != 0){     //throw dice/dice thrown
                // tirar dados
                showThrowDice(g);
                repaint();
            }else if ((state & SHOW_DICE) != 0){
                // dibujamos los dados // draw dice
                dice.paint(g);
            }
        }
    }

    public void initPortTrade(){
        resToChange =-1;
        resIndex =-1;
        actual_banca=0;
        bancaImg=null;
    }

    public void showBanca(Graphics g){
        if (bancaImg==null){
            bancaImg = Image.createImage(73,80);
            bancaGr = bancaImg.getGraphics();

            try{
                Image aux = Image.createImage("/banking.png");
                bancaGr.drawImage(aux,0,0,0);
            }catch (IOException e){}

            //demonstrate amount of cards in trade?    with a vertical bar
            // mostramos el numero de cartas a intercambiar
            // show the number of cards to interchange
            for (int r=0;r<5;r++){ // for each resource
                for (int n=0;n<currentPlayer.getPortTradeRate(r)-2;n++){
                    // la barra blanca         	 // the white bar
                    bancaGr.setStrokeStyle(bancaGr.SOLID);
                    bancaGr.setColor(255,255,255);
                    bancaGr.drawLine(14+6*n,3+15*r,14+6*n,16+15*r);

                    // la imagen de la carta
                    // the image of the card
                    try{
                        Image aux = Image.createImage("/carta_"+Water.ports[r]+".png");//todo missing!
                        bancaGr.drawImage(aux,15+6*n,3+15*r,g.TOP|g.LEFT);
                    }catch (IOException e){}
                }
            }
        }

        Image im = Image.createImage(73,80);
        Graphics gr = im.getGraphics();

        // dibujamos la imagen de background    // draw image at the bottom?/background
        gr.drawImage(bancaImg,0,0,0);

        // demonstrate intertrade selected
        // mostramos el intercambio ya elegido
        //? we showed the chosen interchange already
        gr.setColor(150,150,150);
        if (resToChange !=-1)	gr.drawRect(2,2+15*resToChange,30,15);
        if (resIndex !=-1)	gr.drawRect(38,2+15*resIndex,12,15);

        // mostramos el actual     // we showed the present one
        gr.setColor(0,0,0);
        gr.setStrokeStyle(gr.DOTTED);
        if (actual_banca<5){
            // seleccionado resToChange
            gr.drawRect(2,2+15*(actual_banca%5),30,15);
        }else if (actual_banca<10){
            // seleccionado resIndex
            gr.drawRect(38,2+15*(actual_banca%5),12,15);
        }else{
            // seleccionado ok
            gr.drawRect(55,34,15,11);
        }

        // dibujamos en pantalla
        // we draw on screen
        g.drawImage(im,getWidth()/2,getHeight()/2,g.HCENTER|g.VCENTER);
    }

    public void keyPressedBanca(int k){
        if (k == this.leftKey){
            actual_banca=(actual_banca+(15-5))%15;
        }else if (k == this.rightKey){
            actual_banca=(actual_banca+5)%15;
        }else if (k == this.downKey){
            actual_banca=(actual_banca+1)%5+(actual_banca/5)*5;
        }else if (k == this.upKey){
            actual_banca=(actual_banca+(5-1))%5+(actual_banca/5)*5;
        }else{
            // elige este recurso        // resource selected     // chooses east resource
            if (actual_banca<5)
                resToChange =actual_banca%5;
            else if (actual_banca<10)
                resIndex =actual_banca%5;
            else{
                // ok
                int b;
                if (resToChange !=-1 && resIndex !=-1 &&
                    currentPlayer.getResource(resToChange)>=
                    (b = currentPlayer.getPortTradeRate(resToChange))){
                    currentPlayer.changeResource(resToChange,-b);
                    currentPlayer.changeResource(resIndex,1);
                    state -=PORT_TRADE;
                    initTurn();
                    removeCommand(CancelCommand);
                }
            }
        }
    }

    public void showSelectWho(Graphics g){
        Image im = Image.createImage(85,35);
        Graphics gr = im.getGraphics();

        // I show all those that can choose
        // muestro todos los que puede elegir
        //  playersToStole
        try{
            Image aux = Image.createImage("/steal.png");
            gr.drawImage(aux,0,0,0);
        }catch (IOException e){}

        gr.setColor(currentPlayer.getColor()[0],
                    currentPlayer.getColor()[1],
                    currentPlayer.getColor()[2]);
        gr.drawRect(0,0,84,34);

        int w=(whoSize==3)?22:35;
        int count=0;
        int varX=0;
        for (int i=0;i<numPlayers;i++){
            if (playersToStole[i]==1){
                int[] c = ((Player) players.elementAt(i)).getColor();
                gr.setColor(c[0],c[1],c[2]);
                gr.fillRect(5+count*(w+4),15,w,14);
                if (i==whoIndex) varX=count;
                count++;
            }
        }

        // drawing the box of selection of the chosen one.
        // dibujo el recuadro de seleccion del elegido
        //  whoIndex
        gr.setStrokeStyle(g.DOTTED);
        gr.setColor(0,0,0);
        gr.drawRect(3+varX*(w+4),13,w+4,18);

        // lo dibujamos en el canvas actual
        g.drawImage(im,getWidth()/2,getHeight()/2,g.VCENTER|g.HCENTER);
    }

    public void showSelectField(Coordinate c, Graphics g){
        if (c!=null)
            try{
                Point p = board.map.getPoint(c.c,c.r);
                Image img;
                if ((state & SELECT_EDGE) != 0){
                    img = Image.createImage("/hex_a.png");
                }else if ((state & SELECT_VERTICE) != 0){
                    img = Image.createImage("/hex_v.png");
                }else{ // SELECT_FIELD //CASILLA
                    img = Image.createImage("/hex_c.png");
                }
                g.drawImage(img,p.x,p.y,g.VCENTER|g.HCENTER);
            }catch (IOException e){}
    }

    public void showInfo(Graphics g){
        Image[] im = new Image[numPlayers];
        for (int i=0;i<numPlayers;i++){ //todo lacks lots of images should not work
            try{
                Player j = (Player) players.elementAt(i);
                im[i] = Image.createImage(96,13);
                Graphics gr = im[i].getGraphics();
                gr.setColor(j.getColor()[0],
                            j.getColor()[1],
                            j.getColor()[2]);
                gr.drawRect(0,0,95,12);
                Image imAux = Image.createImage("/info_all.png");
                gr.drawImage(imAux,1,1,g.TOP|g.LEFT);
                gr.fillRect(1,1,11,11);
                imAux = Image.createImage("/mini_"+j.getPoints()+".png"); //todo missing
                gr.drawImage(imAux,6,6,g.HCENTER|g.VCENTER);
                gr.drawLine(31,1,31,11);
                imAux = Image.createImage("/mini_"+j.getNumberOfResourceCards()+".png");
                gr.drawImage(imAux,26,6,g.HCENTER|g.VCENTER);
                gr.drawLine(50,1,50,11);
                imAux = Image.createImage("/mini_"+j.getNumberOfAllDevelopmentCards()+".png");
                gr.drawImage(imAux,45,6,g.HCENTER|g.VCENTER);
                gr.drawLine(69,0,69,11);
                imAux = Image.createImage("/mini_"+j.getKnights()+".png");
                gr.drawImage(imAux,64,6,g.HCENTER|g.VCENTER);
                if (i == ruta_comercial){
                    imAux = Image.createImage("/longroad.png");
                    gr.drawImage(imAux,74,6,g.HCENTER|g.VCENTER);
                }
                if (i == bigArmyOwner){
                    imAux = Image.createImage("/bigArmyOwner.png");
                    gr.drawImage(imAux,82,6,g.HCENTER|g.VCENTER);
                }
                int pv;
                if ((pv = j.getVictoryPoints())>0){
                    imAux = Image.createImage("/victorypoint.png");
                    gr.drawImage(imAux,90,6,g.HCENTER|g.VCENTER);
                    imAux = Image.createImage("/mini_"+pv+".png");
                    gr.drawImage(imAux,90,6,g.HCENTER|g.VCENTER);
                }
            }catch (IOException e){}
            g.drawImage(im[i],getWidth()/2,13+14*i,g.HCENTER|g.TOP);
        }
    }

    public void showResources(Graphics g){
        Player j;
        int i = 0;
        if ((state & SELECT_RESOURCES) != 0){
            j = jugadorActual_SelRec;
            for (int k=0;k<numPlayers;k++){
                Player auxj = (Player) players.elementAt(k);
                if (j.getColor() == auxj.getColor()){
                    i = k;
                    break;
                }
            }
        }else{
            j = currentPlayer;
            i = playerIndex;
        }
        Thread t = Thread.currentThread();
        if (yShowResources ==-72){
            try{//todo use DrawNumber() instead
                imgRecursos = Image.createImage(20,75);
                graphRecursos = imgRecursos.getGraphics();
                Image imgValue = Image.createImage("/resources.png");
                graphRecursos.drawImage(imgValue,0,0,g.TOP|g.LEFT);
                imgValue = Image.createImage("/mini_"+j.getResource(Player.LUMBER)+".png");
                graphRecursos.drawImage(imgValue,4,7,g.VCENTER|g.HCENTER);
                imgValue = Image.createImage("/mini_"+j.getResource(Player.WOOL)+".png");
                graphRecursos.drawImage(imgValue,4,22,g.VCENTER|g.HCENTER);
                imgValue = Image.createImage("/mini_"+j.getResource(Player.GRAIN)+".png");
                graphRecursos.drawImage(imgValue,4,37,g.VCENTER|g.HCENTER);
                imgValue = Image.createImage("/mini_"+j.getResource(Player.BRICK)+".png");
                graphRecursos.drawImage(imgValue,4,52,g.VCENTER|g.HCENTER);
                imgValue = Image.createImage("/mini_"+j.getResource(Player.STONE)+".png");
                graphRecursos.drawImage(imgValue,4,66,g.VCENTER|g.HCENTER);
                graphRecursos.setColor(j.getColor()[0],
                                       j.getColor()[1],
                                       j.getColor()[2]);
                graphRecursos.drawRect(0,-1,20,74);

                imgInfo = Image.createImage(80,12);
                graphInfo = imgInfo.getGraphics();
                graphInfo.setColor(j.getColor()[0],
                                   j.getColor()[1],
                                   j.getColor()[2]);
                graphInfo.drawRect(0,-1,80,12);
                Image imAux = Image.createImage("/info.png");
                graphInfo.drawImage(imAux,0,0,g.TOP|g.LEFT);
                graphInfo.fillRect(0,0,16,10);
                imAux = Image.createImage("/mini_"+j.getPoints()+".png");
                graphInfo.drawImage(imAux,8,5,g.HCENTER|g.VCENTER);
                graphInfo.drawLine(35,0,35,10);
                imAux = Image.createImage("/mini_"+j.getNumDevelopment()+".png");
                graphInfo.drawImage(imAux,30,5,g.HCENTER|g.VCENTER);
                graphInfo.drawLine(54,0,54,10);
                imAux = Image.createImage("/mini_"+j.getKnights()+".png");
                graphInfo.drawImage(imAux,49,5,g.HCENTER|g.VCENTER);
                if (i == ruta_comercial){
                    imAux = Image.createImage("/longroad.png");
                    graphInfo.drawImage(imAux,59,5,g.HCENTER|g.VCENTER);
                }
                if (i == bigArmyOwner){
                    imAux = Image.createImage("/bigArmyOwner.png");
                    graphInfo.drawImage(imAux,67,5,g.HCENTER|g.VCENTER);
                }
                int pv;
                if ((pv = j.getVictoryPoints())>0){
                    imAux = Image.createImage("/victorypoint.png");
                    graphInfo.drawImage(imAux,75,5,g.HCENTER|g.VCENTER);
                    imAux = Image.createImage("/mini_"+pv+".png");
                    graphInfo.drawImage(imAux,75,5,g.HCENTER|g.VCENTER);
                }
            }catch (IOException e){}
        }
        try{
            if (yShowResources <=0){
                yShowResources +=24;
                g.drawImage(imgRecursos,getWidth(),yShowResources,g.RIGHT|g.TOP);
                g.drawImage(imgInfo,1,yShowResources,g.LEFT|g.TOP);
                t.sleep(200);
            }
            if (yShowResources ==0){
                yShowResources =-72;
                state =state -SHOW_RESOURCES +RECURSOS_SHOWN;
            }
        }catch (InterruptedException e){}
    }

    public boolean enoughRoad(Player j){
        return (j.getResource(Player.LUMBER) >= 1) &&
               (j.getResource(Player.BRICK) >= 1) &&
               (j.getNumberOfRoads()<Player.MAX_ROADS);
    }

    public boolean enoughSettlement(Player j){
        return (j.getResource(Player.LUMBER) >= 1) &&
               (j.getResource(Player.BRICK) >= 1) &&
               (j.getResource(Player.WOOL) >= 1) &&
               (j.getResource(Player.GRAIN) >= 1) &&
               (j.getNumberOfSettlements()<Player.MAX_SETTLEMENTS);
    }

    public boolean enoughCity(Player j){
        return (j.getResource(Player.GRAIN) >= 2) &&
               (j.getResource(Player.STONE) >= 3) &&
               (j.getNumberOfCities()<Player.MAX_CITIES);
    }

    public boolean enoughShip(Player j){
        return (j.getResource(Player.LUMBER) >= 1) &&
               (j.getResource(Player.WOOL) >= 1) &&
               (j.getNumberOfShips()<Player.MAX_SHIPS);
    }

    public boolean enoughCard(Player j){
        return (j.getResource(Player.STONE) >= 1) &&
               (j.getResource(Player.WOOL) >= 1) &&
               (j.getResource(Player.GRAIN) >= 1);
    }

    public boolean enoughBank(Player j){
        boolean isEnough = false;
        for (int i=0;i<5;i++){
            isEnough = isEnough || (j.getResource(i) >= j.getPortTradeRate(i));
        }
        return isEnough;
    }

    public void endTurn(){
        removeCommand(PutRoadCommand);
        removeCommand(PutSettlementCommand);
        removeCommand(PutCityCommand);
        removeCommand(PutShipCommand);
        removeCommand(BuyCardCommand);
        removeCommand(PlayCardCommand);
        removeCommand(TradeCommand);
        removeCommand(PortTradeCommand);
        removeCommand(EndTurnCommand);
    }

    public void initTurn(){
        if (enoughRoad(currentPlayer)) addCommand(PutRoadCommand);
        if (enoughSettlement(currentPlayer)) addCommand(PutSettlementCommand);
        if (enoughCity(currentPlayer)) addCommand(PutCityCommand);
        //if (enoughShip(currentPlayer)) addCommand(PutShipCommand); //todo SHIPS ARE DISABLED
        if (enoughCard(currentPlayer)) addCommand(BuyCardCommand);
        if (currentPlayer.getNumDevelopment()>0 && !isPlayed) addCommand(PlayCardCommand);
        addCommand(TradeCommand);
        if (enoughBank(currentPlayer)) addCommand(PortTradeCommand);
        addCommand(EndTurnCommand);
    }

    public void initThrowDice(){
        frameDice =0;
        dice.setLocation(initPDice);
        for (int i=0;i<numPlayers;i++){
            numGold[i]=0;
            Player j = (Player) players.elementAt(i);
            numRecursos[i]=j.getNumberOfResourceCards();
        }
    }

    public void showThrowDice(Graphics g){
        Thread t = Thread.currentThread();
        try{
            if ((state & FIN_DADOS_TIRADOS) != 0){
                t.sleep(1000);
                dice.setLocation(1,70);
                state =state -DICE_THROWN -FIN_DADOS_TIRADOS+SHOW_DICE;
                if (dice.getValue()==7){
                    // enseamos el selectRecursos para todos los players con mas
                    // de 7 cartas
                    // call? enseamos the selectResources() for all players with (more than) but of 7 cards
                    recursosIndexPlayer =playerIndex;
                    boolean found =false;
                    for (int i=recursosIndexPlayer;i<recursosIndexPlayer +numPlayers;i++){
                        if (numRecursos[i%numPlayers]>7){
                            found =true;
                            recursosIndexPlayer =i%numPlayers;
                            break;
                        }
                    }

                    if (found){
                        initSelectResources((Player) players.elementAt(recursosIndexPlayer),
                                           numRecursos[recursosIndexPlayer]/2);
                        state +=SELECT_RESOURCES +MULTI_REMAINING_RESOURCES;
                        endTurn();
                    }else{
                        // movemos el ladron seleccionando la casilla
                            // we move the thief by selecting the square
                        state +=MOVE_ROBBER +SELECT_FIELD;
                    }
                }else{
                    // cogemos los resources correspondientes para cada jugador

                    // recorremos todos los vertices viendo los valores que tienen
                    // contiguos y lo comparamos con el que ha salido en el

                    // we take resources corresponding for each player we cross all the vertices seeing the values
                    // that they have contiguous and we compared it with that it has left in

                    // dice
                    for (Enumeration e = board.getAllCoorVertices();
                         e.hasMoreElements();){
                        Coordinate coor = (Coordinate) e.nextElement();

                        com.jah0wl.catan.items.Item item = board.getVertice(coor);
                        int[][] valoresRecursos = board.getValoresRecursosVertice(coor);


                        // we see the color of the player
                        // vemos el color del jugador
                        int indexJugador=0;
                        Player j=null;
                        for (int k=0;k<numPlayers;k++){
                            j = (Player) players.elementAt(k);
                            if (j.getColor() == item.getColor()){
                                indexJugador=k;
                                break;
                            }
                        }

                        // we see if it is a city or a town
                        // vemos si es una ciudad o un poblado
                        int multFactor=1;
//                        try{
                            if (item instanceof City )//getClass() == Class.forName("City"))
                                multFactor=2;
//                        }catch (ClassNotFoundException exc){}

                        for (int i=0;i<3;i++){
                            if (valoresRecursos[i][0]==dice.getValue()){
// this vertex has a field that gives him resources. this including the thief we already watched resources .

                                // este vertice tiene una casilla que le
                                // dara resources. ya esta incluido el ladron

                                // miramos los resources
                                if (valoresRecursos[i][1]==5){
                                    // oro
                                    numGold[indexJugador]+=multFactor;
                                }else if (valoresRecursos[i][1]!=-1){
                                    // aadimos (give?) resources to the player
                                    // aadimos los resources al jugador
                                    j.changeResource(valoresRecursos[i][1],multFactor);
                                }
                            }
                        }

                    }
                                             // enseamos (call?) the selectRecsources() for all players with golds
                    // enseamos el selectRecursos para todos los players con oros
                    recursosIndexPlayer =playerIndex;
                    boolean found =false;
                    for (int i=recursosIndexPlayer;i<recursosIndexPlayer +numPlayers;i++){
                        if (numGold[i%numPlayers]>0){
                            found =true;
                            recursosIndexPlayer =i%numPlayers;
                            break;
                        }
                    }

                    if (found){
                        initSelectResources((Player) players.elementAt(recursosIndexPlayer),
                                           numGold[recursosIndexPlayer]);
                        state +=SELECT_RESOURCES +MULTI_SUM_RECURSOS;
                        endTurn();
                    }else{
                        initTurn();
                    }
                }
            }else{
                if ((state & THROW_DICE) != 0){
                    // we changed between frames of the dice.
                    frameDice =1-frameDice;
                    t.sleep(200);
                }else if ((state & DICE_THROWN) != 0){


                // has pressed the key to throw says dice that we drew the dices and says wire drawing
                    // han presionado la tecla para tirar el dice as que dibujamos los dados y
                    // el dice tirado
                    frameDice =2;
                }
                try{

                    // we draw frame of corresponding dice
                    // dibujamos el frame del dice correspondiente
                    Image imgDados = Image.createImage("/dado_frame_"+frameDice +".png"); //todo missing
                    g.drawImage(imgDados,getWidth()/2,getHeight()/2,g.VCENTER|g.HCENTER);
                    g.setColor(currentPlayer.getColor()[0],
                               currentPlayer.getColor()[1],
                               currentPlayer.getColor()[2]);
                    g.drawRect(19,24,61,32);
                }catch (IOException e){}
                if ((state & DICE_THROWN) != 0){
                    // has pressed the key to throw the dices that we drew the dices and the dices thrown
                    // han presionado la tecla para tirar el dice as que dibujamos los dados y
                    // el dice tirado
                    dice.paint(g);
                    state +=FIN_DADOS_TIRADOS;
                }
            }
        }catch (InterruptedException e){}
    }

    public void showSelectResources(Graphics g){
        try{
            // pinto el background       // draw background
            Image im = Image.createImage("/selector.png");
            g.drawImage(im,getWidth()/2,getHeight()/2,g.VCENTER|g.HCENTER);

            // pinto el rectangulo del color del jugador
            g.setColor(jugadorActual_SelRec.getColor()[0],
                       jugadorActual_SelRec.getColor()[1],
                       jugadorActual_SelRec.getColor()[2]);
            g.drawRect(7,18,86,43);

            // draw the number of resources q request
            // pinto el numero de resources q piden
            im = Image.createImage("/mini_"+numRecursos_SelRec+".png");
            g.drawImage(im,38+7,5+18,g.VCENTER|g.HCENTER);

            // pinto el numero de resources q ya tan seleccionados
            // draw the number of resources q already so selected
            for (int i=0;i<5;i++){
                im = Image.createImage("/mini_"+recursos_SelRec[i]+".png");        //todo missing
                g.drawImage(im,9+(i*13)+7,34+18,g.VCENTER|g.HCENTER);
            }

            // pinto el rectangulo de seleccion
            g.setColor(0,0,0);
            g.setStrokeStyle(g.DOTTED);
            g.drawRect(rSelection_SelRec[current_SelRec].x,rSelection_SelRec[current_SelRec].y,
                       rSelection_SelRec[current_SelRec].width,rSelection_SelRec[current_SelRec].height);
        }catch(IOException e){}
    }

    protected void keyPressed( int keyCode ){
        // for keys q always is used pa the same
        // para las teclas q siempre se usan pa lo mismo
        fullScreen=false;
        if ((state & SHOW_MAP) != 0){
            state -=SHOW_MAP;
        }else if ((state & RECURSOS_SHOWN) != 0){
            state -=RECURSOS_SHOWN;
            fullScreen=true;
        }else if ((state & SHOW_INFO) != 0){
            state -=SHOW_INFO;
            fullScreen=true;
        }else if ((state & THROW_DICE) != 0){
            dice.changeValue();
            state =state -THROW_DICE +DICE_THROWN;
        }else if (keyCode==starKey){
            state += SHOW_RESOURCES;
        }else if (keyCode==poundKey){
            state += SHOW_INFO;
        }else if (keyCode==numKey[8]){
            state += SHOW_MAP;
        }else{

            // for keys q is used according to present state
            // para las teclas q se usan segun el state actual
            if ((state & SELECT_WHO) != 0){
                keyPressedSelectWho(keyCode);
            }else if ((state & SELECT_RESOURCES) != 0){
                keyPressedSelectResources(keyCode);
            }else  if ((state & PORT_TRADE) != 0){
                keyPressedBanca(keyCode);
            }else if ((state & (SELECT_EDGE | SELECT_VERTICE | SELECT_FIELD)) != 0){
                keyPressedSelectField(keyCode);
            }else if (keyCode==numKey[5]){
                endTurn();
                isPlayed=false;
                currentPlayer.joinDevelopmentCards();
                currentPlayer =(Player) players.elementAt(nextPlayer());
                initThrowDice();
                state =THROW_DICE;
                fullScreen=true;
            }
        }
        repaint();
    }

    public void keyPressedSelectWho(int k){
        if (k==rightKey){
            for (int i=whoIndex+1;i<whoIndex+numPlayers +1;i++){
                if (playersToStole[i%numPlayers]==1){
                    whoIndex=i%numPlayers;
                    break;
                }
            }
        }else if (k==leftKey){
            for (int i=whoIndex+numPlayers +(numPlayers -1);
                 i>whoIndex+(numPlayers -1);i--){
                if (playersToStole[i%numPlayers]==1){
                    whoIndex=i%numPlayers;
                    break;
                }
            }
        }else if (k!=upKey && k!=downKey){
            if ((state & STEALING) != 0){
                int rec;
                Player jug = (Player) players.elementAt(whoIndex);
                if (jug.getNumberOfResourceCards()>0){
                    do{
                        rec = Random.random(5)%5;
                    }while (jug.getResource(rec)==0);
                    jug.changeResource(rec,-1);
                    currentPlayer.changeResource(rec,1);
                }
                state -=STEALING;
                initTurn();
            }else{
                // if we did not rob, we are interchanging resources
                // si no robamos, estamos intercambiando resources
                initTrade(whoIndex);

                // we showed the select_recursos for this player
                // mostramos el select_recursos para este jugador
                initSelectResources(playerTrade,0);
                state =state +SELECT_RESOURCES;
            }
            state -=SELECT_WHO;
        }
    }

    public void initTrade(int index){
        playerTrade = (Player) players.elementAt(index);
        for (int i=0;i<5;i++)
            recursos_SelRec[i]=0;
    }

    public void keyPressedSelectField(int k){
        if (k==downKey){
            if (coorSelect.r<board.map.getRows())
                coorSelect.setCoordinates(coorSelect.c,coorSelect.r+1,0);
        }else if (k==upKey){
            if (coorSelect.r>1)
                coorSelect.setCoordinates(coorSelect.c,coorSelect.r-1,0);
        }else if (k==rightKey){
            if (coorSelect.c<board.map.getCols())
                coorSelect.setCoordinates(coorSelect.c+1,coorSelect.r,0);
        }else if (k==leftKey){
            if (coorSelect.c>1)
                coorSelect.setCoordinates(coorSelect.c-1,coorSelect.r,0);
        }else{
            boolean t;
            boolean isOk=true;
            if ((state & SELECT_VERTICE) != 0){
                if (k==numKey[1]){
                    coorSelect.setCoordinates(coorSelect.c,coorSelect.r,4);
                }else if (k==numKey[3]){
                    coorSelect.setCoordinates(coorSelect.c,coorSelect.r,5);
                }else if (k==numKey[4]){
                    coorSelect.setCoordinates(coorSelect.c,coorSelect.r,3);
                }else if (k==numKey[6]){
                    coorSelect.setCoordinates(coorSelect.c,coorSelect.r,0);
                }else if (k==numKey[7]){
                    coorSelect.setCoordinates(coorSelect.c,coorSelect.r,2);
                }else if (k==numKey[9]){
                    coorSelect.setCoordinates(coorSelect.c,coorSelect.r,1);
                }else
                    isOk=false;

                if (isOk){
                    if ((state & FIRST_SETTLEMENT) != 0){
                        // es el primer poblado //11st settlement
                        if (currentPlayer.putSettlement(board,coorSelect.c,coorSelect.r,coorSelect.pos)){
                            state =state -SELECT_VERTICE+SELECT_EDGE;
                        }
                    }else if ((state & SECOND_SETTLEMENT) != 0){
                        // es el segundo poblado //2nd
                        if (currentPlayer.putSettlement(board,coorSelect.c,coorSelect.r,coorSelect.pos)){
                            getResources(coorSelect);
                            state =state -SELECT_VERTICE+SELECT_EDGE;
                            secondSettlement.setCoordenadas(coorSelect);
                        }
                    }else{	// jugando normalmente si estan seleccionando vertice

                        // playing normally if they estan selecting vertex
                        if ((state & PUT_SETTLEMENT) != 0){
                            if (currentPlayer.putSettlement(board,coorSelect.c,coorSelect.r,coorSelect.pos)){
                                currentPlayer.changeResource(Player.LUMBER,-1);
                                currentPlayer.changeResource(Player.BRICK,-1);
                                currentPlayer.changeResource(Player.WOOL,-1);
                                currentPlayer.changeResource(Player.GRAIN,-1);
                                state =state -PUT_SETTLEMENT -SELECT_VERTICE;
                                commandAction(CancelCommand,this);
                            }
                        }else if ((state & PUT_CITY) != 0){
                            if (currentPlayer.putCity(board,coorSelect.c,coorSelect.r,coorSelect.pos)){
                                currentPlayer.changeResource(Player.STONE,-3);
                                currentPlayer.changeResource(Player.GRAIN,-2);
                                state =state -PUT_CITY -SELECT_VERTICE;
                                commandAction(CancelCommand,this);
                            }
                        }
                    }
                }
            }else if ((state & SELECT_EDGE) != 0){
                if (k==numKey[2]){
                    coorSelect.setCoordinates(coorSelect.c,coorSelect.r,4);
                }else if (k==numKey[4]){
                    coorSelect.setCoordinates(coorSelect.c,coorSelect.r,3);
                }else if (k==numKey[6]){
                    coorSelect.setCoordinates(coorSelect.c,coorSelect.r,5);
                }else if (k==numKey[7]){
                    coorSelect.setCoordinates(coorSelect.c,coorSelect.r,2);
                }else if (k==numKey[9]){
                    coorSelect.setCoordinates(coorSelect.c,coorSelect.r,0);
                }else if (k==numKey[0]){
                    coorSelect.setCoordinates(coorSelect.c,coorSelect.r,1);
                }else
                    isOk=false;

                if (isOk){
                    if ((state & FIRST_SETTLEMENT) != 0){
                        // es la primera carretera           // is the first road
                        if (currentPlayer.putRoad(board,coorSelect.c,coorSelect.r,coorSelect.pos)){
                            if (currentPlayer == (Player) players.lastElement()){

// already has put I complete player and has to put  its second town

                                // ya ha puesto el ultimo jugador y ha de poner
                                // su segundo poblado
                                state =state -FIRST_SETTLEMENT +SECOND_SETTLEMENT;
                            }else{
// // touches to the following player                    (advance to the next player)
                                // le toca al siguiente jugador
                                currentPlayer = (Player) players.elementAt(nextPlayer());
                            }
                            state =state -SELECT_EDGE +SELECT_VERTICE;
                        }
                    }else if ((state & SECOND_SETTLEMENT) != 0){
// is the second highway and it is had to be put next to the second town
                        // es la segunda carretera y se ha de poner al lado del segundo poblado
                        Coordinate[] coorAristas = new Coordinate[3];
                        coorAristas[0]=new Coordinate(secondSettlement.c,secondSettlement.r,(secondSettlement.pos+5)%6);
                        coorAristas[1]=new Coordinate(secondSettlement.c,secondSettlement.r,secondSettlement.pos).getAdjacentFieldEdge();
                        coorAristas[2]=coorAristas[0].getAdjacentFieldEdge();
                        coorAristas[2].pos=(secondSettlement.pos+1)%6;

                        Coordinate cSelectTransl = new Coordinate(coorSelect);
                        cSelectTransl.translEdge();
                        boolean isCoordenadaOk = false;
                        for (int i=0;i<3;i++){
                            coorAristas[i].translEdge();
                            isCoordenadaOk=isCoordenadaOk || coorAristas[i].equals(cSelectTransl);
                        }

                        if (isCoordenadaOk){
                            if (currentPlayer.putRoad(board,coorSelect.c,coorSelect.r,coorSelect.pos)){
                                if (currentPlayer == (Player) players.firstElement()){

                                    // already has put the first player so we played normally
                                    // ya ha puesto el primer jugador asi que jugamos normalmente
                                    initThrowDice();
                                    state =state -SECOND_SETTLEMENT +THROW_DICE;
                                }else{
                                    // advance to the previous
                                    // le toca al jugador anterior
                                    currentPlayer = (Player) players.elementAt(prevPlayer());
                                    state +=SELECT_VERTICE;
                                }
                                state -=SELECT_EDGE;
                            }
                        }
                    }else{

                        // playing normally if they estan selected edge
                        // jugando normalmente si estan seleccionando arista
                        if ((state & PUT_ROAD) != 0){
                            if (currentPlayer.putRoad(board,coorSelect.c,coorSelect.r,coorSelect.pos)){
                                if ((state & EXPANSION) != 0){
                                    numRoadsExp++;
                                    if (numRoadsExp == 2){
                                        state =state -SELECT_EDGE -PUT_ROAD -EXPANSION;
                                        commandAction(CancelCommand,this);
                                    }
                                }else{
                                    currentPlayer.changeResource(Player.LUMBER,-1);
                                    currentPlayer.changeResource(Player.BRICK,-1);
                                    state =state -SELECT_EDGE -PUT_ROAD;
                                    commandAction(CancelCommand,this);
                                }
                            }
                        }else if ((state & PUT_SHIP) != 0){
                            if (currentPlayer.putShip(board,coorSelect.c,coorSelect.r,coorSelect.pos)){
                                currentPlayer.changeResource(Player.LUMBER,-1);
                                currentPlayer.changeResource(Player.WOOL,-1);
                                state =state -SELECT_EDGE -PUT_SHIP;
                                commandAction(CancelCommand,this);
                            }
                        }
                    }
                }
            }else if ((state & SELECT_FIELD) != 0){
                if (board.moveRobber(coorSelect.c,coorSelect.r))
                    isOk=true;
                else
                    isOk=false;

                if (isOk){
                    state +=STEALING;
                    initSelectWho();

                    // now seleccionaria the player of whom it wants to rob
                    // ahora seleccionaria el jugador del que quiere robar
                    for (int i=0;i<6;i++){
                        com.jah0wl.catan.items.Item it = board.getVertice(coorSelect.c,coorSelect.r,i);
                        if (it!=null){
                            for (int j=0;j<numPlayers;j++){
                                Player jug = (Player) players.elementAt(j);
                                if (jug.getColor() == it.getColor() && playersToStole[j]==-1
                                    && playerIndex !=j){
                                    if (whoSize==0) whoIndex=j;
                                    playersToStole[j]=1;
                                    whoSize++;
                                    break;
                                }
                            }
                        }
                    }

                    if (whoSize > 1){
                        state +=SELECT_WHO;
                    }else{
                        if (whoSize == 1){
                            // robamos al unico jugador que hay

                            // we robbed the only player whom there is
                            for (int i=0;i<numPlayers;i++){
                                if (playersToStole[i]==1){
                                    int rec;
                                    Player jug = (Player) players.elementAt(i);
                                    if (jug.getNumberOfResourceCards()>0){
                                        do{
                                            rec = Random.random(5)%5;
                                        }while (jug.getResource(rec)==0);
                                        jug.changeResource(rec,-1);
                                        currentPlayer.changeResource(rec,1);
                                    }
                                    break;
                                }
                            }
                        }
                        // iniciamos el turno normalmente

                        // we initiated the turn normally
                        initTurn();
                        state -=STEALING;
                    }
                    state -=SELECT_FIELD +MOVE_ROBBER;
                }
            }
        }
    }

    public void initSelectWho(){
        whoIndex=-1;
        if ((state & STEALING) != 0){
            for (int i=0;i<numPlayers;i++)
                playersToStole[i] = -1;
            whoSize=0;
            whoIndex=0;
        }else{ // TRADING
            for (int i=0;i<numPlayers;i++)
                if (i!=playerIndex){
                    if (whoIndex==-1) whoIndex=i;
                    playersToStole[i] = 1;
                }else
                    playersToStole[i]=-1;
            whoSize=numPlayers -1;
            endTurn();
            addCommand(CancelCommand);
        }
    }

    public void initSelectResources(Player j, int n){
        numRecursos_SelRec=n;
        for (int i=0;i<5;i++)
            recursos_SelRec[i]=0;
        current_SelRec =0;
        jugadorActual_SelRec=j;
    }

    public void keyPressedSelectResources(int k){
        if (k == this.leftKey){
            current_SelRec =(current_SelRec +(6-1))%6;
        }else if (k == this.rightKey){
            current_SelRec =(current_SelRec +1)%6;
        }else{
            if (current_SelRec == 5){         // ok pressed
                // estamos sobre el ok //we are ok
                if ((state & MONOPOLIO) != 0){
                    // le restamos a todos los players todos los resources del elegido de cada
                    // uno y se lo sumamos al jugador actual

// we reduced to all players all resources to him of the chosen one of each one and we added the present player
                    for (int r=0;r<5;r++){
                        if (recursos_SelRec[r]>0){
                            for (int j=0;j<numPlayers;j++){
                                if (j!=playerIndex){
                                    Player jug = (Player) players.elementAt(j);
                                    int rec=jug.getResource(r);
                                    jug.changeResource(r,-rec);
                                    currentPlayer.changeResource(r,rec);
                                }
                            }
                        }
                    }
                    state -=MONOPOLIO+SELECT_RESOURCES;
                    commandAction(CancelCommand,this);
                }else if ((state & TRADING) != 0){
                    boolean weCan = true;
                    for (int i=0;i<5;i++){
                        weCan = weCan &&
                                jugadorActual_SelRec.getResource(i) >= recursos_SelRec[i];
                    }

                    if (weCan){
                        if ((state & TRADING_ACTUAL) != 0){
                            // sumamos al jugador actual los resources del otro y se los restamos a el
                            // we added to the present player resources of the other and we reduced them to
                            for (int i=0;i<5;i++){
                                jugadorActual_SelRec.changeResource(i,tradeOtherRec[i]);
                                playerTrade.changeResource(i,-tradeOtherRec[i]);
                                jugadorActual_SelRec.changeResource(i,-recursos_SelRec[i]);
                                playerTrade.changeResource(i,recursos_SelRec[i]);
                            }
                            // ya hemos acabado // already we have finished
                            state -=TRADING+TRADING_ACTUAL+SELECT_RESOURCES;
                            commandAction(CancelCommand,this);
                        }else{
                            for (int i=0;i<5;i++)
                                tradeOtherRec[i] = recursos_SelRec[i];

                            // seleccionamos los resources del jugador actual
                            // we selected resources of the present player

                            initSelectResources(currentPlayer,0);
                            state +=TRADING_ACTUAL;
                        }
                    }
                }else if (numRecursos_SelRec == 0){
                    if ((state & MULTI_SUM_RECURSOS) != 0){
                        // sumamos los oros al jugador actual
                        for (int i=0;i<5;i++)
                            jugadorActual_SelRec.changeResource(i,recursos_SelRec[i]);
                        numGold[recursosIndexPlayer]=0;
                                                                  // we looked for the following player .
                        // buscamos el siguiente jugador
                        boolean encontrado=false;
                        for (int i=recursosIndexPlayer +1;i<recursosIndexPlayer +numPlayers +1;i++){
                            if (numGold[i%numPlayers]>0){
                                encontrado=true;
                                recursosIndexPlayer =i%numPlayers;
                                break;
                            }
                        }

                        if (encontrado){
// // we initiated so that the following player chooses his resources.
                                                    // iniciamos para que el siguiente jugador elija sus resources
                            initSelectResources((Player) players.elementAt(recursosIndexPlayer),numGold[recursosIndexPlayer]);
                        }else{
                            // // already we have finished .
                                                    // ya hemos acabado
                            state -=MULTI_SUM_RECURSOS +SELECT_RESOURCES;
                            initTurn();
                        }
                    }else if ((state & MULTI_REMAINING_RESOURCES) != 0){
                        // // we watched if we can reduce resources to him
                                                // miramos si podemos restarle los resources
                        boolean weCan = true;
                        for (int i=0;i<5;i++){
                            weCan = weCan &&
                                    jugadorActual_SelRec.getResource(i) >= recursos_SelRec[i];
                        }


                        if (weCan){
                            // restamos los resources al jugador actual

// we reduced resources to the present player .
                            for (int i=0;i<5;i++)
                                jugadorActual_SelRec.changeResource(i,-recursos_SelRec[i]);
                            numRecursos[recursosIndexPlayer]=0;

                            // we looked for the following player
                            // buscamos el siguiente jugador
                            boolean found =false;
                            for (int i=recursosIndexPlayer +1;i<recursosIndexPlayer +numPlayers +1;i++){
                                if (numRecursos[i%numPlayers]>7){
                                    found =true;
                                    recursosIndexPlayer =i%numPlayers;
                                    break;
                                }
                            }

                            if (found){
                                // we initiated so that the following player chooses his resources.
                                // iniciamos para que el siguiente jugador elija sus resources
                                initSelectResources((Player) players.elementAt(recursosIndexPlayer),numRecursos[recursosIndexPlayer]/2);
                            }else{
                                // ya hemos acabado// already we have finished.
                                state -=MULTI_REMAINING_RESOURCES +SELECT_RESOURCES;
                                // ahora debemos mover el ladron  // now we must move the thief .
                                state +=MOVE_ROBBER +SELECT_FIELD;
                            }
                        }
//						else{// has not chosen resources correct so we left such it as //}
//							No ha elegido los resources correctos asi que lo dejamos tal cual
//						}
                    }else if ((state & SUMA_RECURSOS) != 0){

                        // adds resources to the present player.
                        // se suman los resources al jugador actual
                        for (int i=0;i<5;i++)
                            jugadorActual_SelRec.changeResource(i,recursos_SelRec[i]);
                        // cambiamos el state  // we changed state
                        state -=SUMA_RECURSOS+SELECT_RESOURCES;
                        endTurn();
                        initTurn();
                    }
                }
            }else{
                if (k == this.downKey){
                    if (recursos_SelRec[current_SelRec]>0){
                        recursos_SelRec[current_SelRec]--;
                        if (!((state & TRADING) != 0))
                            numRecursos_SelRec++;
                    }
                }else if (k == this.upKey){
                    if (recursos_SelRec[current_SelRec]<19){
                        if ((state & TRADING) != 0)
                            recursos_SelRec[current_SelRec]++;
                        else if (numRecursos_SelRec > 0){
                            numRecursos_SelRec--;
                            recursos_SelRec[current_SelRec]++;
                        }
                    }
                }
            }
        }
    }

    protected void keyRepeated(int keyCode) {
        keyPressed(keyCode);
    }

    public int nextPlayer(){
        playerIndex =(playerIndex +1)%numPlayers;
        return playerIndex;
    }

    public int prevPlayer(){
        playerIndex =(playerIndex +numPlayers -1)%numPlayers;
        return playerIndex;
    }

    public void getResources(Coordinate c){
        Coordinate cont[] = new Coordinate[2];
        cont[0] = new Coordinate(c.c,c.r,c.pos%6).getAdjacentFieldEdge();
        cont[1] = new Coordinate(c.c,c.r,(c.pos+5)%6).getAdjacentFieldEdge();

        Field fld[] = new Field[3];
        fld[0] = board.map.getField(c.c,c.r);
        fld[1] = board.map.getField(cont[0].c,cont[0].r);
        fld[2] = board.map.getField(cont[1].c,cont[1].r);

        int numGold =0;
        for (int i=0;i<3;i++){
//            try{
                if (fld[i] instanceof Terrain){ //.getClass() == Class.forName("Terrain")){
                    Terrain l = (Terrain) fld[i];
                    if ((state & SECOND_SETTLEMENT) != 0){

// has put the second aadimos town and him 1 resource of each one to the present player.
                        // han puesto el segundo poblado y le aadimos
                        // 1 recurso de cada uno al jugador actual
                        int recurso = l.getResource();
                        if (recurso==l.GOLD)
                            numGold++;
                        else
                            currentPlayer.changeResource(recurso,1);
                    }else{
                        // hay que mirar que ha salido en los dados
                        // is necessary to watch that it has left in the dices
                    }
                }
//            }catch (ClassNotFoundException e){}
        }
        if (numGold >0){
            initSelectResources(currentPlayer,numGold);
            state +=SELECT_RESOURCES +SUMA_RECURSOS;
        }
    }

    public void commandAction(Command c, Displayable d){
        if (d==listDevelopment){
            if (c==listDevelopment.SELECT_COMMAND){
                // han seleccionado una carta      // has selected a card
                int play = currentPlayer.getDevelopment()[listDevelopment.getSelectedIndex()];
                switch (play){
                case Player.KNIGHT:
                    currentPlayer.addKnight();
                    int knight;
                    if ((knight = currentPlayer.getKnights())>=3){
                        boolean isBigArmy =true;
                        for (int i=0;i<numPlayers;i++){
                            Player j = (Player) players.elementAt(i);
                            isBigArmy =isBigArmy &&
                                (i == playerIndex ||
                                knight > j.getKnights());
                        }
                        if (isBigArmy){
                            if (bigArmyOwner !=-1){
                                Player j = (Player) players.elementAt(bigArmyOwner);
                                j.changeScore(-2);
                            }
                            bigArmyOwner =playerIndex;
                            currentPlayer.changeScore(2);
                        }
                    }
                    // movemos el ladron  // move robber
                    endTurn();
                    currentPlayer.removeDevelopmentCard(play);
                    isPlayed=true;
                    state +=MOVE_ROBBER +SELECT_FIELD;
                    break;
                case Player.MONOPOLY:
                    initSelectResources(currentPlayer,1);
                    endTurn();
                    currentPlayer.removeDevelopmentCard(play);
                    isPlayed=true;
                    state +=MONOPOLIO+SELECT_RESOURCES;
                    break;
                case Player.EXPANSION:
                    numRoadsExp =0;
                    endTurn();
                    currentPlayer.removeDevelopmentCard(play);
                    isPlayed=true;
                    state +=EXPANSION+SELECT_EDGE +PUT_ROAD;
                    break;
                case Player.DISCOVERY:
                    initSelectResources(currentPlayer,2);
                    state +=SELECT_RESOURCES +SUMA_RECURSOS;
                    currentPlayer.removeDevelopmentCard(play);
                    isPlayed=true;
                    break;
                case Player.PROGRESS:
                    currentPlayer.addVictoryPoint();
                    endTurn();
                    currentPlayer.removeDevelopmentCard(play);
                    isPlayed=true;
                    initTurn();
                    break;
                }
            }
            midlet.display.setCurrent(this);
            listDevelopment =null;     //todo what for??
        }else{
            if (c==exitCommand){
                midlet.exit();
            }else if (c==CancelCommand){
                removeCommand(CancelCommand);
                initTurn();
                state = SHOW_DICE;
            }else if (c==showResourcesCommand){
                if ((state & SHOW_INFO) != 0)
                    state -=SHOW_INFO;
                if ((state & SHOW_MAP) != 0)
                    state -=SHOW_MAP;
                if (!((state & SHOW_RESOURCES) != 0))
                    state +=SHOW_RESOURCES;
            }else if (c==showInfoCommand){
                if ((state & SHOW_RESOURCES) != 0)
                    state -=SHOW_RESOURCES;
                if ((state & SHOW_MAP) != 0)
                    state -=SHOW_MAP;
                if (!((state & SHOW_INFO) != 0))
                    state +=SHOW_INFO;
            }else if (c==showMapCommand){
                if ((state & SHOW_INFO) != 0)
                    state -=SHOW_INFO;
                if ((state & SHOW_RESOURCES) != 0)
                    state -=SHOW_RESOURCES;
                if (!((state & SHOW_MAP) != 0))
                    state +=SHOW_MAP;
            }else if (c==PutRoadCommand){
                state =PUT_ROAD +SELECT_EDGE;
                endTurn();
                addCommand(CancelCommand);
            }else if (c==PutSettlementCommand){
                state =PUT_SETTLEMENT +SELECT_VERTICE;
                endTurn();
                addCommand(CancelCommand);
            }else if (c==PutCityCommand){
                state =PUT_CITY +SELECT_VERTICE;
                endTurn();
                addCommand(CancelCommand);
            }else if (c==PutShipCommand){
                state =PUT_SHIP +SELECT_EDGE;
                endTurn();
                addCommand(CancelCommand);
            }else if (c==BuyCardCommand){
                currentPlayer.changeResource(Player.WOOL,-1);
                currentPlayer.changeResource(Player.STONE,-1);
                currentPlayer.changeResource(Player.GRAIN,-1);
                currentPlayer.addDevelopment();
                endTurn();
                initTurn();
            }else if (c==TradeCommand){
                state =TRADING;
                if (numPlayers ==2){      //!only two players
                    initTrade(nextPlayer());
                    nextPlayer();       // revert it back


// we showed the select_recursos for this player
                    // mostramos el select_recursos para este jugador
                    initSelectResources(playerTrade,0);
                    state +=SELECT_RESOURCES;
                }else{
                    initSelectWho();
                    state +=SELECT_WHO;
                }
                endTurn();
                addCommand(CancelCommand);
            }else if (c==PortTradeCommand){
                state =PORT_TRADE;
                endTurn();
                initPortTrade();
                addCommand(CancelCommand);
            }else if (c==EndTurnCommand){
                endTurn();
                isPlayed=false;
                currentPlayer.joinDevelopmentCards();
                currentPlayer =(Player) players.elementAt(nextPlayer());
                initThrowDice();
                state =THROW_DICE;
            }else if (c==PlayCardCommand){
                initListDevelopment();
                midlet.display.setCurrent(listDevelopment);
            }
            fullScreen=true;
        }
    }

    public void randomizePlayers(){
        Vector aux = new Vector();
        while (!players.isEmpty()){
            Player j = (Player) players.elementAt(Random.random(players.size())%players.size());
            aux.addElement(j);
            players.removeElement(j);
        }
        players = aux;
    }

    public void initListDevelopment(){
        listDevelopment = new List("Development Cards",listDevelopment.IMPLICIT);
//        listDevelopment = new List("Cartas de desarrollo",listDevelopment.IMPLICIT);
        int[] dev = currentPlayer.getDevelopment();
        Image[] im = new Image[dev.length];
        for (int i=0;i<dev.length;i++){
            try{
                im[i] = Image.createImage(Player.strDevelopment[dev[i]][2]);
            }catch (IOException e){}
            listDevelopment.append(Player.strDevelopment[dev[i]][0]+": "+
                                  Player.strDevelopment[dev[i]][1],im[i]);
        }

        listDevelopment.addCommand(CancelCommand);
        listDevelopment.setCommandListener(this);
    }


}
