package com.jah0wl.catan;

import com.jah0wl.utils.*;
import com.jah0wl.catan.utils.*;
import com.jah0wl.catan.items.Item;
import com.jah0wl.catan.items.Settlement;
import com.jah0wl.catan.fields.*;

class Player {
	
	// colores                  // colours
	public final static int[] RED ={255,0,0};
	public final static int[] GREEN ={0,255,0};
	public final static int[] BLUE ={0,0,255};
	public final static int[] GOLD ={255,255,0};	//amarillo
	public final static int[] CIAN={0,255,255};	
	public final static int[] MAGENTA={255,0,255};		
	
	// valores  //values
	public static int MAX_SETTLEMENTS;
	public static int MAX_CITIES;
	public static int MAX_ROADS;
	public static int MAX_SHIPS;
	public static int MAX_POINTS;
	
	private int num_settlements;
	private int num_cities;
	private int num_roads;
	private int num_ships;
	private int num_bonus_points;
	
	private int[] color;	
	
	public static final int LUMBER =0;
	public static final int WOOL =1;
	public static final int GRAIN =2;
	public static final int BRICK =3;
	public static final int STONE =4;
		
	private int[] resources = new int[5];
	private int[] bank = new int[5]; //port trade rate for each resource  (initially 4)


    // Moves the thief off  .// All resources of all. // To construct two highways. // Two resources free. // Point of victory. ;

    public static final int KNIGHT =0; // Mueve el ladron de sitio       // move robber
	public static final int MONOPOLY =1; // Todos los resources de todos
	public static final int EXPANSION=2; //	Construir dos carreteras  //construct 2 roads
	public static final int DISCOVERY =3; // Dos resources gratis
	public static final int PROGRESS =4; // Punto de victoria	   // points of victory
	
	public static final String[][] strDevelopment =
//	{{"Caballero","Cambia el ladrn de posicin","/knight.png"},
//	 {"Monopolio","Todos los players te dan todos los resources del recurso elegido","/monopoly.png"},
//	 {"Expansin","Construye dos carreteras sin gastos de resources","/expansion.png"},
//	 {"Descubrimiento","Elige dos resources gratis","/discovery.png"},
//	 {"Progreso","Un punto de victoria","/progress.png"}};      //todo add this pictures
	{{"Knight","Changes the robber position","/knight.png"},                  //todo missing png
	 {"Monopoly","All players give you all resourses of the chosen resource","/monopoly.png"},
	 {"Expansion","Build 2 roads w/o expenses of resourses","/expansion.png"},
	 {"Discovery","Get 2 resources for free","/discovery.png"},
	 {"Progress"," a point of victory","/progress.png"}};


//{{Horseman, Changes ladrn of posicin, /knight.png "},
// // {Monopoly, All players give all resources you of the chosen resource, /monopoly.png "}, // {Expansin, Constructs two highways without expenses of resources, /expansion.png "}, // {Discovery, Chooses two free resources, /discovery.png "}, // {Progress, a point of victory, /progress.png "}};


    private int[] developmentCards = new int[19];
    private int numberOfDevelopmentCards;
    //! just bought so can't use them
	private int[] thisTurnDevelopmentCards = new int[19];
	private int thisTurnNumberOfDevelopmentCards;
	
	private int knights; // size of player's army (#of used knights)
	
	private int score;
	
	private int victoryPoints;
	
	private int port;
	
	// Constructor
	public Player(int[] c){
		color=c;
		num_settlements =0;
		num_cities =0;
		num_roads =0;
		num_ships =0;
		num_bonus_points =0;
		for (int i=0;i<5;i++){
			resources[i]=0;
			bank[i]=4;	
		}
		score = 0;
		victoryPoints =0;
		numberOfDevelopmentCards =0;
		thisTurnNumberOfDevelopmentCards =0;
	}	
	
	// Observadoras selectoras
	public int getNumberOfSettlements(){
		return num_settlements;
	}
	
	public int getNumberOfCities(){
		return num_cities;
	}
	
	public int getNumberOfRoads(){
		return num_roads;
	}
	
	public int getNumberOfShips(){
		return num_ships;
	}
	
	public int getNumberOfBonusPoints(){
		return num_bonus_points;
	}	
	
	public int[] getColor(){
		return color;
	}
	
	public int getResource(int r){
		return resources[r];
	}

	public int getNumberOfResourceCards(){
		int ret=0;
		for (int i=0;i<5;i++)
			ret+=resources[i];
		return ret;
	}
	
	public int getPoints(){
		return score;
	}
	
	public int getVictoryPoints(){
		return victoryPoints;
	}
	
	public int getNumDevelopment(){
		return numberOfDevelopmentCards;
	}
	
	public int[] getDevelopment(){
		int[] ret = new int[numberOfDevelopmentCards];
		for (int i=0;i<numberOfDevelopmentCards;i++)
			ret[i]=developmentCards[i];
		return ret;
	}
	
	public int getNumberOfAllDevelopmentCards(){
		return numberOfDevelopmentCards + thisTurnNumberOfDevelopmentCards;
	}
	
	public int getKnights(){
		return knights;
	}
	
	public int getPortTradeRate(int r){
		return bank[r];
	}

    /**
     * Changes the amount of resource by a given value,
     * according to resources[r] in [0,19]
     * @param r     resource type
     * @param var   value
     */
    public void changeResource(int r, int var){
		if (resources[r]+var<0)
			resources[r]=0;
		else if (resources[r]+var>19)
			resources[r]=19;
		else
			resources[r]+=var;
	}
	
	public void changeScore(int var){
		score +=var;
	}

	public void addVictoryPoint(){
		score++;
		victoryPoints++;
	}

    //todo Development cards don't vanish from the game, i.e. prob. is fixed is this fine?
    public void addDevelopment(){
		if (numberOfDevelopmentCards +thisTurnNumberOfDevelopmentCards <19){
			int[] randomize = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,1,1,2,2,4,4};
			thisTurnDevelopmentCards[thisTurnNumberOfDevelopmentCards++]=
                    randomize[Random.random(randomize.length)%randomize.length];
		}
	}
	
	public boolean removeDevelopmentCard(int d){
		boolean found =false;
		for (int i=0;i<numberOfDevelopmentCards;i++){
			if (developmentCards[i]==d)

// we have found it and from aqu there is q to erase
                // la hemos encontrado y a partir de aqu hay q borrar
				found =true;
			if (found && i<numberOfDevelopmentCards -1)
				developmentCards[i]=developmentCards[i+1];
		}
		if (found)	numberOfDevelopmentCards--;
		return found;
	}
	
	public void addKnight(){
		knights++;
	}
	
	public void setAllBank(int num){
		for (int i=0;i<5;i++){
			if(bank[i]>num)bank[i]=num; //corrected this error, but one cannot use this method for initialisation
		}
	}
	
	public void setBank(int r, int num){
		bank[r]=num;
	}

    // we passed cards of development of this turn to the general
	// pasamos las cartas de developmentCards de este turno al general
    // add just bought development cards to other development cards
    public void joinDevelopmentCards(){
		for (int i=0;i<thisTurnNumberOfDevelopmentCards;i++)
			developmentCards[numberOfDevelopmentCards++]=thisTurnDevelopmentCards[i];
		thisTurnNumberOfDevelopmentCards =0;
	}

    // operations with tokens/cards
    // Operaciones con fichas
	public boolean putSettlement(Board t, int c, int r, int pos){
		int check = checkCrossing(t,c,r,pos);    //checkCruce
		if ((num_settlements <2 && check>=1) ||      // no settlements near, 1st or 2nd settlement don't need road
			(num_settlements <MAX_SETTLEMENTS && check==2)){ // not settlements near and player has a road
			t.addSettlement(c,r,pos,color);
			if (port !=-1){     // there is a port near
				if (port ==5)
					setAllBank(3);  //todo THIS IS AN ERROR
				else
					setBank(port,2);
			}
			num_settlements++;
			changeScore(1);
			return true;
		}else
			return false;
	}
	
	public boolean putCity(Board t, int c, int r, int pos){
		Item i = t.getVertice(c,r,pos);
//		try{
			if (num_cities <MAX_CITIES &&
				i!=null && i.getColor()==color &&
				i instanceof Settlement){ //.getClass()==Class.forName("Settlement")){
				t.addCity(c,r,pos,color);
				num_cities++;
				num_settlements--;
				changeScore(1);
				return true;
			}else
				return false;
//		}catch (ClassNotFoundException e){
//			return false;
//		}
	}	
	
	public boolean putRoad(Board t, int c, int r, int pos){
		int check = checkEdge(t,c,r,pos);
		if (check == -1)
			return false;
		if (num_roads <MAX_ROADS &&
			(check & CAN_ROAD) != 0 &&
			((check & 2) != 0 || 
			 ((check & 1) != 0 &&
			  (isInCamino(t,c,r,pos) || isInCamino(t,c,r,(pos+1)%6))))){
			t.addRoad(c,r,pos,color);
			num_roads++;  //todo why it doesn't check for a long road??
			return true;
		}else
			return false;
	}	

	public boolean putShip(Board t, int c, int r, int pos){
		int check = checkEdge(t,c,r,pos);
		if (check == -1)
			return false;
		else if (num_ships <MAX_SHIPS &&
			(check & CAN_BARCO) != 0 &&
			((check & 2) != 0 || 
			 ((check & 1) != 0 &&
			  (isInCamino(t,c,r,pos) || isInCamino(t,c,r,(pos+1)%6))))){
			t.addShip(c,r,pos,color);
			num_ships++;
			return true;
		}else
			return false;
	}		
	                                //camino = walk
	public boolean isInCamino(Board t, int c, int r, int pos){
		return true;
	}

    //! also sets "port" variable

    //Sees if this crossing is empty,
    // if there is a highway of ours touching the vertex
    // and says if there are no towns in a distance of 1

    // Mira si esta vacio el cruce, si hay una carretera nuestra tocando
	// el vertice dice y  si no hay poblados a una distancia de 1
	
	// Return
	//		-1 : no esta vacio el cruce o no hay tirea                        // not empty
	//		0  : esta vacio el cruce, pero hay poblados a distancia de uno.   // has settlements near/all water
	//		1  : esta vacio el cruce y no hay poblados a distancia de uno,
	//			 pero no hay carretera nuestra  // no settlements near but no roads
	//		2  : esta vacio el cruce, hay carretera nuestra y   // no settlements near and have a road
	//		     no hay poblados a distancia de uno


    // -1: this crossing is empty or is no terrain
    // 0: this  crossing is empty , but are remote towns of distanceone.
    // 1: this crossing is empty and are no remote towns of one,
    //  but there is no highway of ours
    // 2: this crossing is empty, there is a highway of  ours and
    // are no remote towns of distance one

    private int checkCrossing(Board t, int c, int r, int pos){
		if (!t.isVerticeEmpty(c,r,pos))
			return -1;
		else{
			Coordinate[] coorEdges = new Coordinate[3];
			Coordinate[] coorVertices = new Coordinate[3];
		
			coorEdges[0]=new Coordinate(c,r,(pos+5)%6);
			coorEdges[1]=new Coordinate(c,r,pos).getAdjacentFieldEdge();
			coorEdges[2]=coorEdges[0].getAdjacentFieldEdge();
			coorEdges[2].pos=(pos+1)%6;
		
			coorVertices[0]=new Coordinate(c,r,(pos+5)%6);
			coorVertices[1]=new Coordinate(c,r,(pos+1)%6);
			coorVertices[2]=coorEdges[0].getAdjacentFieldEdge();
			coorVertices[2].pos=(pos+1)%6;


// We watch if no field of the crossing is terrain
            // Miramos si ninguna casilla del cruce es tierra
			port =-1;
			boolean hasTerrain =false;
			for (int i=0;i<3;i++){
				Field k = t.map.getField(coorEdges[i].c,coorEdges[i].r);
//				try{
					if (k instanceof Water){ //.getClass() == Class.forName("Water")){
						Water a = (Water) k;
						if (a.getPort()!=-1){
							// traducimos el vertice original
// we translate the original vertex
							Coordinate coor = new Coordinate(c,r,pos);
							coor.translVertice();
							// traducimos la arista que tiene el agua
                            // we translate the edge that has the water
                            Coordinate aris = new Coordinate(coorEdges[i]);
							aris.pos=a.getPosition();
							aris.translEdge();
							// traducimos los vrtices de la arista
                            // we translate the vertices of the edge
                            Coordinate[] vert = new Coordinate[2];
							vert[0] = new Coordinate(aris);
							vert[0].translVertice();
							vert[1] = new Coordinate(aris);
							vert[1].pos=(vert[1].pos+1)%6;
							vert[1].translVertice();
							
							if (vert[0].equals(coor) || vert[1].equals(coor))
								port =a.getPort();
						}
					}else
						hasTerrain =true;
				}
//                catch(ClassNotFoundException e){}
//			}
			if (!hasTerrain)
				return 0;
			else{
				for (int i=0;i<3;i++){
                    // We watched if there is some town in the vertices.
                    // Miramos si hay algun poblado en los vertices
					if (!t.isVerticeEmpty(coorVertices[i]))
						return 0;
					// Miramos si hay carretera nuestra en las aristas
                    // We watched if there is highway of ours in the edges
                    if (!t.isEdgeEmpty(coorEdges[i])){
						Item it = t.getEdge(coorEdges[i]);
						if (it.getColor()==this.color)
						return 2;
					}
				}	
				return 1;
			}
		}
	}
	
	// Mira si esta vacia la arista, si hay una carretera nuestra pegando
	// o si hay un poblado o ciudad nuestro pegando tb
// Check if the this empty edge, if there is a highway ours sticking or if there is a town or city ours sticking tb

    // Return
	//		-1 : no esta vacia la arista          //edge not empty
	//		0  : esta vacia la arista, pero no hay ni poblados, ni ciudades,
	//			 ni carreteras nuestras contiguas   //no tokens, no roads
	//		1  : esta vacio el cruce y hay carreteras contiguas, pero no
	//			 un poblado o ciudad        //has adjacent roads but no tokens
	//		2  : esta vacio el cruce y hay poblados o ciudades contiguos      // has adjacent tokens
	//
	// Flags (solo para 1 y 2)
	//      CAN_BARCO : si se puede poner barco
	//		CAN_ROAD  : si se puede poner carretera


// -1:  this edge is not empty
// // 0: the this empty edge, but has neither settlements no cities   nor our contiguous roads
//  1: this crossing is empty and there are contiguous roads, but no settlement or or city
// 2: this crossing is empty and are contiguous towns or cities
// // // Flags (single for 1 and 2)
// // CAN_BARCO: if boat can be put
// // CAN_ROAD: if road can be put

    private final static int CAN_BARCO	= 4;       // can put ship
	private final static int CAN_ROAD	= 8;	
	
	private int checkEdge(Board t, int c, int r, int pos){
		if (!t.isEdgeEmpty(c,r,pos))
			return -1;
		else{
			int ret=-1;
			
			Coordinate[] coorEdges = new Coordinate[4];
			Coordinate[] coorVertices = new Coordinate[2];
			Coordinate[] coorFields = new Coordinate[2];

            // gets two fields adjacent to this edge
            coorFields[0] = new Coordinate(c,r,pos);
			coorFields[1] = coorFields[0].getAdjacentFieldEdge();

            // gets two adjacent eges from the same field
            coorEdges[0]=new Coordinate(c,r,(pos+1)%6);
			coorEdges[1]=new Coordinate(c,r,(pos+5)%6);
            // gets two adjacent edges from the adjacent field
            coorEdges[2]=new Coordinate(c,r,pos).getAdjacentFieldEdge();
			coorEdges[2].pos=(coorEdges[2].pos+1)%6;
			coorEdges[3]=new Coordinate(c,r,pos).getAdjacentFieldEdge();
			coorEdges[3].pos=(coorEdges[3].pos+5)%6;

            // gets two adjacent verticies (of the same hexagon)
            coorVertices[0]=new Coordinate(c,r,pos);
			coorVertices[1]=new Coordinate(c,r,(pos+1)%6);

            //one of the verticies has our colour => our settlement or city
            for (int i=0;i<2;i++){
				if (!t.isVerticeEmpty(coorVertices[i]) &&
					t.getVertice(coorVertices[i]).getColor()==color){
					ret=2;
					break;
				}
			}

            // one of the edges has our colour
            if (ret==-1){
				for (int i=0;i<4;i++){
					if (!t.isEdgeEmpty(coorEdges[i]) &&
						t.getEdge(coorEdges[i]).getColor()==color){
						ret=1;
						break;
					}
				}
			}
			
			if (ret==-1)
				return 0; // has no adjacent tokens or roads
			else{// check adjacent fields => what we can build
				Field c1 = t.map.getField(coorFields[0].c,coorFields[0].r);
				Field c2 = t.map.getField(coorFields[1].c,coorFields[1].r);
				boolean isAgua1=false;
				boolean isAgua2=false;
				
//				try{
					isAgua1 = c1 instanceof Water;//.getClass() == Class.forName("Water");
					isAgua2 = c2 instanceof Water;//.getClass() == Class.forName("Water");
//				}catch (ClassNotFoundException e){}

				if (isAgua1 || isAgua2)   // has adjacent water
					ret+=CAN_BARCO;
				if (!isAgua1 || !isAgua2) // has adjacent terrain
					ret+=CAN_ROAD;

				return ret;
			}
		}
	}
	
}
