package com.jah0wl.catan;

import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Font;
import com.jah0wl.utils.*;

public class ProgressBar{
	
	private Rectangle bounds;
		
	private int value;
	
	private Font font;
	
	// Constructor
	ProgressBar(Rectangle r, int v){
		this(r.x,r.y,r.width,r.height,v);
	}
	ProgressBar(Point p, int w, int h, int v){
		this(p.x,p.y,w,h,v);
	}
	ProgressBar(int x,int y, int w, int h, int v){
		bounds = new Rectangle(x,y,w,h);
		value =v;
		font = Font.getFont(Font.FACE_MONOSPACE,Font.STYLE_PLAIN,
							Font.SIZE_SMALL);		
	}
	
	// Observadoras selectoras
	public Rectangle getBounds(){
		return new Rectangle(bounds);
	}
	
	public Point getLocation(){
		return bounds.getLocation();
	}
	
	public int getValue(){
		return value;
	}
	
	public void setBounds(Rectangle r){
		bounds=r;
	}
	
	public void setLocation(Point p){
		setLocation(p.x,p.y);
	}
	public void setLocation(int x, int y){
		bounds.setLocation(x,y);
	}
	
	public void setValue(int v){
		if (v>100)
			value =100;
		else
			value =v;
	}
	
	
	// Otras operaciones
	public void paint(Graphics g){
		g.setStrokeStyle(g.SOLID);
		// dibujamos el borde        // draw the border
		g.setColor(0,150,200);
		g.drawRect(bounds.x,bounds.y,bounds.width,bounds.height);
		
		// dibujamos la porcin completa           // we drew porcin completes.
		g.fillRect(bounds.x,bounds.y,
				   value *(bounds.width)/100,bounds.height);
		
		// dibujamos el porcentaje en negro // we drew the percentage in black
//		g.setFont(font);
//		g.setColor(0,0,0);
//		String str = value+"%";
//		g.drawString(str,(bounds.x+bounds.width/2)-font.stringWidth(str)/2+2,
//					 bounds.y+1,g.TOP|g.LEFT);
	}
}