package com.jah0wl.utils;

public class Rectangle{
	
	public int x;
	public int y;	
	public int width;
	public int height;
	
	// Constructor
	public Rectangle(){
		this(0,0,0,0);	
	}
	public Rectangle(int w, int h){
		this(0,0,w,h);	
	}	
	public Rectangle(Point p, int w, int h){
		this(p.x,p.y,w,h);
	}
	public Rectangle(Rectangle r){
		this(r.x,r.y,r.width,r.height);
	}
	public Rectangle(int x, int y, int w, int h){
		this.x=x;
		this.y=y;
		this.width=w;
		this.height=h;
	}

	// Observadoras selectoras
	public boolean equals(Object o){
		return ((Rectangle) o).x == this.x &&
			   ((Rectangle) o).y == this.y &&
			   ((Rectangle) o).width == this.width && 
			   ((Rectangle) o).height == this.height;
	}
	
	public Point getLocation(){
		return new Point(x,y);
	}
	
	public void setLocation(Point p){
		this.setLocation(p.x,p.y);
	}
	public void setLocation(int x, int y){
		this.x=x;
		this.y=y;
	}
	
	// Otras operaciones
	public void Move(int x, int y){
		this.x+=x;
		this.y+=y;
	}
	
	public boolean inside(Point p){
		return (x<=p.x) && (p.x<=x+width) &&
			   (y<=p.y) && (p.y<=y+height);
	}
	public boolean inside(Rectangle r){
		return inside(r.getLocation()) &&
			   inside(new Point(r.x+r.width,r.y)) &&
			   inside(new Point(r.x,r.y+r.height)) &&
			   inside(new Point(r.x+r.width,r.y+r.height));		
	}
	
	public boolean intersects(Rectangle r){
		return inside(r.getLocation()) ||
			   inside(new Point(r.x+r.width,r.y)) ||
			   inside(new Point(r.x,r.y+r.height)) ||
			   inside(new Point(r.x+r.width,r.y+r.height));
	}

	private int min(int a, int b){
		return (a<=b)?a:b;
	}
	
	private int max(int a, int b){
		return (a<=b)?b:a;
	}
	
	public void union(Rectangle r){
		Rectangle rec =
			new Rectangle(min(this.x,r.x),min(this.y,r.y),
						  max(this.x+this.width,r.x+r.width)-min(this.x,r.x),
						  max(this.y+this.height,r.y+r.height)-min(this.y,r.y));
		this.setLocation(rec.getLocation());
		this.width=rec.width;
		this.height=rec.height;
	}
}	